﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=1.45
@EndOfDesignText@
'Class module
Sub Class_Globals
	
End Sub

Public Sub Initialize

End Sub

Sub Handle(req As ServletRequest, resp As ServletResponse)
	If req.Method <> "POST" Then
		resp.SendError(500, "method not supported.")
		Return
	End If
	
	Dim path As String = TestAndCreateFolder ' every time or once a day @ 00:00:00 ?
	
	'we need to call req.InputStream before calling GetParameter.
	'Otherwise the stream will be read internally (as the parameter might be in the post body).
	Dim In As InputStream = req.InputStream
	Dim reqType As String = req.GetParameter("type")
	If reqType = "" Then
		resp.SendError(500, "Missing type parameter.")
		Return
	End If
	Select reqType
		Case "text"
			Dim tr As TextReader
			tr.Initialize(In)
			Log("Received text message: " & CRLF & tr.ReadAll)
			resp.Write("Message received successfully.")
		
		Case "file"
			Dim name As String = req.GetParameter("name")
			Dim out As OutputStream = File.OpenOutput(path, name, False)
			File.Copy2(In, out)
			out.Close
			Log("Received file: " & name & ", size=" & File.Size(path, name))
			resp.SetHeader("StoragePath",path&"/"&name) ' return path of the file
			resp.Write("File received successfully.")
	End Select
End Sub

Sub TestAndCreateFolder As String
	Dim DrivePrefix As String = "C:/" 'windows
	Dim RootFolder As String = "Uploads"

	
	Dim year As Int = DateTime.GetYear(DateTime.Now)
	Dim month As Int =DateTime.Getmonth(DateTime.Now)
	Dim day As Int = DateTime.GetDayOfMonth(DateTime.Now)
	
'	Dim filename As String = RootFolder & "/" & year
'	Dim filename2 As String = RootFolder & "/" & year & "/" & month
	Dim filename3 As String = RootFolder & "/" & year & "/" & month & "/" & day
	
	
	If File.Exists(DrivePrefix,filename3) = True Then
'		If File.Exists(DrivePrefix,filename2) = False Then
'			File.MakeDir(DrivePrefix, filename2)
'		End If
'		If File.Exists(DrivePrefix,filename3) = False Then
'			File.MakeDir(DrivePrefix, filename3)
'		End If
	Else
		
		File.MakeDir(DrivePrefix, filename3)
	
	End If
	Return DrivePrefix&filename3
	
End Sub